--== Options ==--
-- 1 to enable; false to disable
local background = true --little background behind the unit frames
local healthtext_opt = true --text for health or not
local leader = true -- leader icon or not
local RI = true  -- raid icons or not
local name_opt = true -- name text or not

--== Textures Options ==--
local color
local font, fontsize = "Fonts\\FRIZQT__.ttf", 12		-- The font and fontsize
local backdrop2 = {
	bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
	insets = {top = -1, left = -1, bottom = -1, right = -1},
}
--local statusbar = "Interface\\AddOns\\RaccoonUI\\textures\\dP"
local statusbar = [[Interface\Addons\oUF_Deith\media\pHishTex15]]
local glowTex = [[Interface\Addons\oUF_Deith\media\glowTex]]
local border = [[Interface\AddOns\oUF_Deith\media\gloss5]]		-- Buff borders
local playerClass = select(2, UnitClass("player"))
local color_rb = 0
local color_gb = 0
local color_bb = 0
local alpha_fb =1
--== End of textures options ==--

local function SetFontString(parent, fontName, fontHeight, fontStyle)
	local fs = parent:CreateFontString(nil, 'OVERLAY')
	fs:SetFont(fontName, fontHeight, fontStyle)
	fs:SetJustifyH('LEFT')
	fs:SetShadowColor(0,0,0)
	fs:SetShadowOffset(1.25, -1.25)
	return fs
end


local menu = function(self)
	local unit = self.unit:sub(1, -2)
	local cunit = self.unit:gsub("(.)", string.upper, 1)

	if(unit == "party" or unit == "partypet") then
		ToggleDropDownMenu(1, nil, _G["PartyMemberFrame"..self.id.."DropDown"], "cursor", 0, 0)
	elseif(_G[cunit.."FrameDropDown"]) then
		ToggleDropDownMenu(1, nil, _G[cunit.."FrameDropDown"], "cursor", 0, 0)
	end
end 

local function Style(self, unit)
	self.colors = colors
	self.menu = menu
	self:RegisterForClicks('AnyUp')
	self:SetAttribute('*type2', 'menu')
	self:SetScript('OnEnter', UnitFrame_OnEnter)
	self:SetScript('OnLeave', UnitFrame_OnLeave)
	
	--== Unit Backgrounds ==--
if background == true then
	self:SetBackdrop(backdrop2)
	self:SetBackdropColor(0,0,0,1)
	
	self.FrameBackdrop = CreateFrame("Frame", nil, self)
	self.FrameBackdrop:SetPoint("TOPLEFT", self, "TOPLEFT", -4.5, 4)
	self.FrameBackdrop:SetFrameStrata("BACKGROUND")
	self.FrameBackdrop:SetBackdrop {
	  edgeFile = glowTex, edgeSize = 8,
	  insets = {left = 3, right = 3, top = 3, bottom = 3}
	}
	self.FrameBackdrop:SetBackdropColor(0, 0, 0, 0)
	self.FrameBackdrop:SetBackdropBorderColor(0, 0, 0)

	if unit == "player" and class == "DEATHKNIGHT" or IsAddOnLoaded("oUF_TotemBar") and unit == "player" and class == "SHAMAN" then
		self.FrameBackdrop:SetPoint("BOTTOMRIGHT", self, "BOTTOMRIGHT", 4.5, -12)
	else
		self.FrameBackdrop:SetPoint("BOTTOMRIGHT", self, "BOTTOMRIGHT", 4.5, -4.5)
	end
end
	--== Movable frames ==--
	self.MoveableFrames = true
	--== BarFader options ==--
	self.BarFade = true
	self.BarFadeMinAlpha = 0.15
	
	self.Health = CreateFrame('StatusBar', nil, self)
	self.Health:SetPoint"TOP"
	self.Health:SetStatusBarTexture(statusbar)
	self.Health:SetStatusBarColor(.3,.3,.3,1)
	self.Health:SetHeight(7)
	
	self.Health.bg = self.Health:CreateTexture(nil, "BORDER")
	self.Health.bg:SetAllPoints(self.Health)
	self.Health.bg:SetTexture(statusbar)
	self.Health.bg:SetVertexColor(0.15,.15,0.15)
	
	self.Health:SetPoint"RIGHT"
	self.Health:SetPoint"LEFT"
	self.Health.colorDisconnected = true 
	self.Health.colorClass = false
	
if healthtext_opt == true then
	local Healthtext = SetFontString(self.Health, font, 12) 
	Healthtext:SetJustifyH('LEFT')
	self:Tag(Healthtext,'[deith:gradienthp]')
	Healthtext:SetPoint('BOTTOM',self,'TOP',0,2)
end	


	
	--== Leader Icon ==--
if leader == true then
	self.Leader = self.Health:CreateTexture(nil, 'OVERLAY')
	self.Leader:SetPoint('TOPRIGHT', self, -1,-1 )
	self.Leader:SetHeight(16)
	self.Leader:SetWidth(16)
end

	--== Raid Icons ==--
if RI == true then
	self.RaidIcon = self.Health:CreateTexture(nil, 'OVERLAY')
	self.RaidIcon:SetPoint('BOTTOM', self.Portrait,'TOP' ,0,3)
	self.RaidIcon:SetHeight(16)
	self.RaidIcon:SetWidth(16)
end

	--== The name customisation ==--
if name_opt == true then
	local Name = SetFontString(self.Health, font, 10) 
	Name:SetPoint('RIGHT',self,'LEFT',0,-.45) 
	self:Tag(Name,'[raidcolor][deith:shortname]|r [level] [shortclassification] ')
	if unit == 'targettarget' then
		Name:ClearAllPoints()
		Name:SetJustifyH("RIGHT")
		Name:SetPoint('LEFT',self,'RIGHT',10,-.45)
	end
end
	

	self:SetAttribute('initial-height', 7)        -- the frames' height 
	self:SetAttribute('initial-width', 100)        -- the frames' width
	
	
	return self
end


oUF:RegisterStyle("Deith_Small", Style)	
		
